
//+------------------------------------------------------------------+
//|                                                                  |
//|                      GAHelloWorld.mq4                            |
//|                                                                  |
//+------------------------------------------------------------------+

#property show_inputs

#import "kernel32.dll"
 bool QueryPerformanceCounter(int& counter[]);
#import

extern string ____Note____ = "Try this script with any other target string!";
extern string TargetString = "Hello World! This is a target string example!";

string individual[];
int min, length, popsize, fitness[], multipler=10;
//+------------------------------------------------------------------+
int RandomCharCode() {

 int counter[2];
 if (QueryPerformanceCounter(counter)) {
  int code = 32 + MathAbs(counter[0] % 224);
 }
 return(code);
}
//+------------------------------------------------------------------+
void InitializeIndividuals() {

 for(int i=0; i<popsize; i++) {
  string  str = "";
  string char = " ";
  for(int j=0; j<length; j++) {
   str = str + StringSetChar(char,0,RandomCharCode());
  }
  individual[i] = str;
 }
}
//+------------------------------------------------------------------+
void CalculateFitness() {

 for(int i=0; i<popsize; i++) {
  int fit = 0;
  for(int j=0; j<length; j++) {
   fit += MathAbs(StringGetChar(individual[i],j) - StringGetChar(TargetString,j));
  }
  fitness[i] = fit;
 }
}
//+------------------------------------------------------------------+
void UpdateIndividuals() {

 string best = individual[min];
 
 for(int i=0; i<popsize; i++) {
  
  int     pos = i % length;
  int oldcode = StringGetChar(best,pos);
  int   newup = oldcode + 1;
  int   newdn = oldcode - 1;
  
  if(newup > 255) {newup = 255;}
  if(newdn <  32) {newdn =  32;}
  
  if(i < length) {
   individual[i] = StringSetChar(best,pos,newup);
  }
  else if(i >= length && i < length * 2) {
   individual[i] = StringSetChar(best,pos,newdn);
  }
  else {
   individual[i] = StringSetChar(best,pos,RandomCharCode());
  }
 }
}
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start() {

 int StartTime = GetTickCount();
 
 length = StringLen(TargetString);
	popsize = length * multipler;
	
	ArrayResize(fitness,popsize);
 ArrayResize(individual,popsize);
 
 InitializeIndividuals();
 CalculateFitness();
	
	int i = 0;
	while(fitness[min] > 0) {
	
	 UpdateIndividuals();
  CalculateFitness();
  min = ArrayMinimum(fitness);
  
  if(fitness[min] > 0) {
	  Comment("\n"+" Current Iteration: "+i+", Fitness: "+fitness[min]+" Best individual: "+individual[min]);
	  Print("Current Iteration: "+i+", Fitness: "+fitness[min]+", Best individual: "+individual[min]);
	 }
	 else {
	  double ExecutionTime = (GetTickCount() - StartTime) / 1000.0;
	  Comment("\n"+" Target found!"+"\n"+" Iterations used: "+i+"\n"+" Execution time: "+DoubleToStr(ExecutionTime,3)+
	  " seconds"+"\n"+" Target string length: "+length+" characters"+"\n"+" Target string: "+individual[min]);
	  Print("Target found!"+"  Iterations used: "+i+", Target string: "+individual[min]);
	  break;
	 }
	 i++;
	}
 return(0);
}
//+------------------------------------------------------------------+